function twist=ftwist(th,param,data)
alpha   = param(1);
% beta    = param(2);
% gam     = param(3);
rho     = param(4);
psi     = param(5);
gbar    = param(6);
% gdbar   = param(7);
sx      = param(8);
sg      = param(9);
sd      = param(10);
sp      = param(11);
coefx   = param(12);
coefc   = param(13);
spi     = sqrt(pi);
spi3    = spi*spi*spi;

XX      = data.xcx;
x       = data.x;
y       = data.y1d;
wy      = data.w1d;
e       = data.y3d;
we      = data.w3d;
K       = data.k;
nint    = size(y,1);
nint3   = size(e,1);
% nodes   = size(XCX,1);
% INT consists of
% ex eg ed
% 1  2  3

C       = XX(:,1);
X       = XX(:,2);
outer   = 0;
for i=1:nint;
    gp      = gbar+rho*(X+sp*y(i))+sg*e(:,2)+sx*e(:,1);
    nup     = [rho*sp*y(i)+sg*e(:,2)+sx*e(:,1) psi*rho*sp*y(i)+sd*e(:,3)+psi*sx*e(:,1)];
    xp      = coefx*(rho*X+nup*K');
    cp      = coefc*(C+gp);
    Tp      = makepoly_v([cp xp]);
    vtp     = exp(Tp*th);
    tmp     = we'*vtp/spi3;
    outer   = outer+exp(-alpha*tmp)*wy(i)/spi;
end

inner   = 0;
for j=1:nint3;
    gp      = gbar+rho*x(:)+sg*e(j,2)+sx*e(j,1);
    nup     = [rho*(x(:)-X)+sg*e(j,2)+sx*e(j,1) psi*rho*(x(:)-X)+sd*e(j,3)+psi*sx*e(j,1)];
    xp      = coefx*(rho*X+nup*K');
    cp      = coefc*(C+gp);
    Tp      = makepoly_v([cp xp]);
    vtp     = exp(Tp*th);
    inner   = inner+vtp*we(j)/spi3;
end
Inner   = exp(-alpha*inner);
twist   = Inner./outer;