function RES=resid_rp(thp,param,data,th,varargin)
alpha   = param(1);
beta    = param(2);
gam     = param(3);
rho     = param(4);
psi     = param(5);
gbar    = param(6);
gdbar   = param(7);
sx      = param(8);
sg      = param(9);
sd      = param(10);
sp      = param(11);
coefx   = param(12);
coefc   = param(13);

spi     = sqrt(pi);
spi3    = spi*spi*spi;

X       = data.x;
TP      = data.tp;
if nargin>4
    X   = data.xd;
    TP  = data.tpd;
end
WX      = data.wx;
y       = data.y1d;
wy      = data.w1d;
e       = data.y3d;
we      = data.w3d;
K       = data.k;
nint    = size(y,1);
nint3   = size(e,1);

% e consists of
% ex eg ed
% 1  2  3
C       = X(:,1);
X       = X(:,2);
outer   = 0;
outer2  = 0;
for i=1:nint;
    inner   = 0;
    mpj     = 0;
    yi      = y(i);
    wi      = wy(i);
    for j=1:nint3;
        gp      = gbar+rho*(X+sp*yi)+sg*e(j,2)+sx*e(j,1);
        gdp     = gdbar+rho*psi*(X+sp*yi)+sd*e(j,3)+psi*sx*e(j,1);
        nup     = [rho*sp*yi+sg*e(j,2)+sx*e(j,1);psi*rho*sp*y(i)+sd*e(j,3)+psi*sx*e(j,1)];
        xp      = coefx*(rho*X+K*nup);
        cp      = coefc*(C+gp);
        Tvp     = makepoly_v([cp xp]);
        Tpp     = makepoly_p([cp xp]);
        inner   = inner+exp(Tvp*th)*we(j)/spi3;
        mpj     = mpj+exp(Tpp*thp).*exp(gdp-gam*gp)*we(j)/spi3;
    end
    Inner   = exp(-alpha*inner);
    outer   = outer+Inner*wi/spi;
    outer2  = outer2+(Inner.*mpj)*wi/spi;
end
if nargin>4
    RES = (beta*outer2./outer).^(-1/gam)-1;
else
%     RES = TP'*(WX.*(beta*outer2./outer-exp(P)));
    RES = TP'*(WX.*(beta*outer2./outer-1));
end

