function RES=resid_v(th,param,data,varargin)

alpha   = param(1);
beta    = param(2);
% gam     = param(3);
rho     = param(4);
psi     = param(5);
gbar    = param(6);
% gdbar   = param(7);
sx      = param(8);
sg      = param(9);
sd      = param(10);
sp      = param(11);
coefx   = param(12);
coefc   = param(13);
spi     = sqrt(pi);
spi3    = spi*spi*spi;

XX      = data.x;
TV      = data.tv;
U       = data.u;
if nargin>3
    XX  = data.xd;
    TV  = data.tvd;
    U   = data.ud;
end
WX      = data.wx;
y       = data.y1d;
wy      = data.w1d;
e       = data.y3d;
we      = data.w3d;
K       = data.k;
nint    = size(y,1);
nint3   = size(e,1);
% e consists of
% ex eg ed
% 1  2  3
C       = XX(:,1);
X       = XX(:,2);
outer   = 0;
for i=1:nint;
    inner=0;
    yi  = y(i);
    wi  = wy(i);
    for j=1:nint3;
        gp      = gbar+rho*(X+sp*yi)+sg*e(j,2)+sx*e(j,1);
        nup     = [rho*sp*yi+sg*e(j,2)+sx*e(j,1);psi*rho*sp*yi+sd*e(j,3)+psi*sx*e(j,1)];
        xp      = coefx*(rho*X+K*nup);
        cp      = coefc*(C+gp);
        Tp      = makepoly_v([cp xp]);
        inner   = inner+exp(Tp*th)*we(j)/spi3;
    end
    outer   = outer+exp(-alpha*inner)*wi/spi;
end
rhs = (1-beta)*U-beta*log(outer)/alpha;
vt  = exp(TV*th);

if nargin>3
    RES = 1-rhs./vt;
else
    RES = TV'*(WX.*(vt-rhs));
end
