close all
clc
clear all
load CMTS_2011_data_v5
YR = years;
scale = 100;

y=[RPCCG';RPCDG'];
y=y*scale;
yOrig = y;
%y=y(:,1:48);

mu=mean(y'); %#ok<UDIM>
H=diag(var(y')); %#ok<UDIM>
Q=sqrt(prod(diag(H)));
psi = 3;
Z=[1 psi]';
rho=.9;

options = optimset('fminsearch');
options.Display='off';
y=y';
y = bsxfun(@minus,y,mean(y));
y=y';
p=fminsearch('kf_bivariate_bansalyaron_wraper',log([H(1,1) H(2,2) Q]),options,[0 0 Z(1) Z(2) rho],[0 0 0 0 0 1 1 1],y,0,1/(1-rho^2));

options = optimset('fminunc');
options.Display='off';
options.LargeScale='off';


options = optimset('fminsearch');
options.Display='off';

options = optimset('fminunc');
options.Display='off';
options.LargeScale='off';



count=1;
rhos = .9:-.05:0;
pfinal = zeros(length(rhos),4);
for rho=rhos
    disp(rho);
    y=yOrig;
    y=y';
    y = bsxfun(@minus,y,mean(y));
    y=y';
    y=y(:,1:48);
    
    options = optimset('fminsearch');
    options.Display='off';
    p=fminsearch('kf_bivariate_bansalyaron_wraper',log([H(1,1) H(2,2) Q]),options,[0 0 Z(1) Z(2) rho],[0 0 0 0 0 1 1 1],y,0,1/(1-rho^2));
    
    options = optimset('fminunc');
    options.Display='off';
    options.LargeScale='off';
    p=fminunc('kf_bivariate_bansalyaron_wraper',p,options,[0 0 Z(1) Z(2) rho],[0 0 0 0 0 1 1 1],y,0,1/(1-rho^2));
    pfinal(count,:) = [rho exp(p(1:3))/scale^2];
    p_bivarate{count}=p; %#ok<*SAGROW>
    Z=[1 psi]';
    
    y=yOrig;
    [VCV,A,B] =  robustvcv('kf_bivariate_bansalyaron_wraper_inference',p,0,[0 0 Z(1) Z(2) rho],[0 0 0 0 0 1 1 1],y,0,1/(1-rho^2));
    V = diag(exp(p_bivarate{count})/100^2)*VCV*diag(exp(p_bivarate{count})/100^2);
    p_bivaraite{count} = exp(p_bivarate{count})/100^2;
    stdErr{count} = sqrt(diag(V));
    
    y=y';
    y = bsxfun(@minus,y,mean(y));
    y=y';
    [LLFs{count},afits{count},Ps{count},LLFs_indiv{count}]=kf_bivariate_bansalyaron_wraper(p,[0 0 Z(1) Z(2) rho],[0 0 0 0 0 1 1 1],y,0,1/(1-rho^2));
    count=count+1;
end

